{$R+}
var
  x, y, a: array of Integer;
  N, S, i, j, k, p, h, c, m, t, xa, ya, xb, yb: Integer;
  f: TextFile;
begin
  AssignFile(f, 'input.txt'); Reset(f);
  Read(f, N, S);
  SetLength(x, N);
  SetLength(y, N);
  SetLength(a, N);
  for i := 0 to N - 1 do
    Read(f, x[i], y[i]);
  CloseFile(f);

  for i := 0 to N - 2 do begin
    m := i;
    for j := i + 1 to N - 1 do begin
      if x[j] < x[m] then m := j;
    end;
    if m > i then begin
      t := x[i]; x[i] := x[m]; x[m] := t;
      t := y[i]; y[i] := y[m]; y[m] := t;
    end;
  end;

  m := 0; xa := x[0]; ya := y[0]; xb := x[0]; yb := y[0];
  for i := 0 to N - 2 do begin
    a[0] := i;
    c := 1;
    for j := i + 1 to N - 1 do begin
      k := c;
      while (k > 0) and (y[a[k - 1]] > y[j]) do begin
        a[k] := a[k - 1];
        Dec(k);
      end;
      a[k] := j;
      Inc(c);

      if x[j] > x[i] then
        h := S div (x[j] - x[i])
      else
        h := MaxInt;
      p := 0;
      for k := 0 to c - 1 do begin
        while y[a[k]] - y[a[p]] > h do Inc(p);
        if k - p > m then begin
          m := k - p;
          xa := x[i]; xb := x[j];
          ya := y[a[p]]; yb := y[a[k]];
        end;
      end;
    end;
  end;

  AssignFile(f, 'output.txt'); Rewrite(f);
  Writeln(f, xa, ' ', ya, ' ', xb, ' ', yb);
  CloseFile(f);
end.
